#include <SPI.h>
#include <MFRC522.h> 
#define SS_PIN 10
#define RST_PIN 9
MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance.
String object_1 = "10 AA 73 5B";
String object_2 = "F7 5A 73 5B";
String object_3 = "E5 54 AA A5";
String object_4 = "CE 5B 74 5B";
String object_5 = "11 BC 73 5B";
int correctOrder[]={2,4,3,5,1};
int scanedOrder[]={0,0,0,0,0};
int count=0;
int ledGreen=7;
int ledOrange=6;
int ledRed=5;
const int buzzer = 8;

/*void setColor(int red1, int green1, int blue1)
{
  #ifdef COMMON_ANODE
    red1 = 255 - red1;
    green1 = 255 - green1;
    blue1 = 255 - blue1;
  #endif
  analogWrite(redRGB, red1);
  analogWrite(greenRGB, green1);
  analogWrite(blueRGB, blue1);  
}*/

void setup() {
  // put your setup code here, to run once:
 Serial.begin(9600);   // Initiate a serial communication
  SPI.begin();      // Initiate  SPI bus
  mfrc522.PCD_Init();   // Initiate MFRC522
  Serial.println("Approximate your card to the reader...");
  Serial.println();
  pinMode(ledGreen, OUTPUT); 
  pinMode(ledRed, OUTPUT); 
  pinMode(ledOrange,OUTPUT);
  pinMode(buzzer, OUTPUT);
  
}

void loop() {
  
  // put your main code here, to run repeatedly:
 if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) 
  {
    return;
  }
  //Show UID on serial monitor
  Serial.print("UID tag :");
  String content= "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++) 
  {
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     Serial.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print("Message : ");
  content.toUpperCase(); 


  int currentObject=0; // ποιο ΕΙΝαι σκαναρισμενο ασχετως σειρας

if (content.substring(1) == object_1)
        currentObject=1;
if (content.substring(1) == object_2)
        currentObject=2;
if (content.substring(1) == object_3)
        currentObject=3;
if (content.substring(1) == object_4)
        currentObject=4;
if (content.substring(1) == object_5)
        currentObject=5;




  Serial.print (count);
  bool repeat=false;//τσεκαρουμε αν εχει σκαναρισκει ξανα
  
  for ( int i = count; i>=0; i--)
  { if (scanedOrder[i]== currentObject)
       repeat=true;
       tone(buzzer, 1000); // Send 1KHz sound signal...
      delay(100);
      noTone(buzzer);
  }

  if (!repeat)
  {
      scanedOrder[count]=currentObject;
      count++;
      
  }

if (count==5) // θεσεις απο το 0-4
  {
      int correct=0;
     for (int i=0; i<count; i++) //μετραμε πόσα σωστα υπάχρουν στον πινακα scanedOrder
  {
        if (scanedOrder[i]==correctOrder[i])
        correct++; // ειναι ιδια σε καποια απο τις 5 θεσεις υπάρχει ένα σωστο 
     
    }
    
switch (correct) //ME LED
    {
      case 0:
      digitalWrite(ledRed, HIGH);
      Serial.print ("kokkino");
      //ledPinKOkkino (HIGH) DES TON ALLO KODIKA
      delay(20000);
      digitalWrite(ledRed, LOW);
      //digitalWrite(ledPin,LOW);  να σβησει το λεντ 
      break;
      
      case 1 :
      //ledPinKOkkino (HIGH) DES TON ALLO KODIKA
      digitalWrite(ledRed, HIGH);
       Serial.print ("kokkino");
      delay(20000);
      //digitalWrite(ledPin,LOW);
      digitalWrite(ledRed, LOW);
      break;
      
       case 2:
      digitalWrite(ledRed, HIGH);
       Serial.print ("kokkino");
      delay(20000);
      digitalWrite(ledRed, LOW);
      break;
      
       case 3:
      digitalWrite(ledOrange, HIGH);
        Serial.print ("portokali");
      delay(20000);
      digitalWrite(ledOrange, LOW);
      break;
      
       case 4:
       digitalWrite(ledOrange, HIGH);
        Serial.print ("portokali");
      delay(20000);
       digitalWrite(ledOrange, LOW);
      break;
      
       case 5:
        digitalWrite(ledGreen, HIGH);
          Serial.print ("prasino");
      //ledPinprasini (HIGH) DES TON ALLO KODIKA
      //playmusic //μην ξεχασεις το delay! αν δεν δουλευει
      delay(20000); //oso paizei to mp3
       digitalWrite(ledGreen, LOW);
      //digitalWrite(ledPin,LOW);//digitalWrite(ledPin,LOW);
      break;
      
      
      }

      
      count=0;
   
   for (int i=0; i<5; i++)
    scanedOrder[i]=0;
    
  }

  
  

  
  }
  
  

