
#include <SPI.h>
#include <MFRC522.h> 
#define SS_PIN 10
#define RST_PIN 9
MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance.
const int buzzer = 8; //buzzer to arduino pin 8
const int ledPin = 7;
const int buttonPin = 2;
int redRGB = 3;
int greenRGB = 5;
int blueRGB = 6;
String player_pink = "93 60 BF 59";
String player_green = "4C F1 A5 A9";
String player_orange = "41 FB BD 89";
String player_red = "62 9C A4 A9";
String player_blue = "6E 05 E3 29";
String object_1 = "10 AA 73 5B";
String object_2 = "F7 5A 73 5B";
String object_3 = "E5 54 AA A5";
String object_4 = "CE 5B 74 5B";
String object_5 = "11 BC 73 5B";
bool pink = false;
bool green = false;
bool orange = false;
bool red = false;
bool blue = false;
long randomNumber=0;
int PlayerToPlay[]={1,2,3,4,5}; // το δημιουργήσαμε για να ξερούμε πόσοι παίχτες είναι
int Prow[]={6,6,6,6,6};//η σειρά που θα παίξουν οι παίχτες
int PlayerHasToPlay[]={0,0,0,0,0};// πόσοι παίχτες έχουν χάσει την πρώτη σείρα και θα ξαναπαίξουν
// variables will change:
int buttonState = 0;         // variable for reading the pushbutton status
int count =0;
int Player=0;
long StartTime=-1;
int counter2=0;

void setColor(int red1, int green1, int blue1)
{
  #ifdef COMMON_ANODE
    red1 = 255 - red1;
    green1 = 255 - green1;
    blue1 = 255 - blue1;
  #endif
  analogWrite(redRGB, red1);
  analogWrite(greenRGB, green1);
  analogWrite(blueRGB, blue1);  
}
void setup() 
{
  Serial.begin(9600);   // Initiate a serial communication
  SPI.begin();      // Initiate  SPI bus
  mfrc522.PCD_Init();   // Initiate MFRC522
  Serial.println("Approximate your card to the reader...");
  Serial.println();
  pinMode(ledPin, OUTPUT);
  pinMode(buzzer, OUTPUT); // Set buzzer - pin 9 as an output
  pinMode(buttonPin, INPUT); 
  randomSeed(analogRead(0));//για να μην παίζουν με την ίδια σειρά οι παίχτες με κάνε ενεργοποίηση του arduino
  pinMode(redRGB, OUTPUT); 
  pinMode(greenRGB, OUTPUT); 
  pinMode(blueRGB,OUTPUT);
  int p_count=0;
  while(p_count<5) // 
  {
    randomNumber = random(5);
    bool exists=false;
    for (int i=0; i< 5;i++)
    {
      if(Prow[i]==randomNumber)
      exists=true;
    }
    if(!exists)
    {
      Prow[p_count]=randomNumber;
      p_count++;
    }
    else
     exists=false;
  }
   //Serial.println(Prow);

  
 // if analog input pin 0 is unconnected, random analog
  // noise will cause the call to randomSeed() to generate
  // different seed numbers each time the sketch runs.
  // randomSeed() will then shuffle the random function.
 // if analog input pin 0 is unconnected, random analog
  // noise will cause the call to randomSeed() to generate
  // different seed numbers each time the sketch runs.
  // randomSeed() will then shuffle the random function.
  
  
}
void loop() 
{ 
  if (StartTime!=-1)
  if(millis()- StartTime>300000) //αν ο χρόνος είναι μεγαλύτερος από τα 5 λεπτά τότε πάμε στον επόμενο παίχτη
  {
    count++;//παμε στον επομενο παίχτη
    StartTime=-1;
    PlayerHasToPlay[counter2]=Player;//
    counter2++;
    
    
    } 
    
  if(count<5){
    
  Player=PlayerToPlay[Prow[count]];
  Serial.print (Player);
  switch(Player) //ΦΤΙΑΞΕ ΤΑ ΧΡΩΜΑΤΑ
  {
    case 1:
   setColor(158, 4, 79);//roz 158, 4, 79
    break;
    
    case 2:
    setColor(0, 255, 0);  // green 0, 255, 0
    break;
    
    case 3:
    setColor(255, 0, 0);   //kokkino 255, 0, 0
    break;
    
    case 4:
     setColor(200, 200, 0); //kitrino 255, 255, 0
    break;
    
    case 5:
     setColor(0, 0, 255);  // blue 0, 0, 255
    break;
    
    default:
    break;
  }
  }
  else {
    if (counter2>0){
      if(count-5<counter2)
      {
    Player=PlayerHasToPlay[count-5];
    Serial.print (Player);
     switch(Player) //ΦΤΙΑΞΕ ΤΑ ΧΡΩΜΑΤΑ
  {
    case 1:
   setColor(158, 4, 79);//roz
    break;
    
    case 2:
    setColor(0, 255, 0);  // green
    break;
    
    case 3:
    setColor(255, 0, 0);   //kokkino
    break;
    
    case 4:
     setColor(200, 200, 0); //kitrino
    break;
    
    case 5:
     setColor(0, 0, 255);  // blue
    break;
    
    default:
    break;
  }
      }
      else{
        Serial.print ("end of the game");
          
        }
    }
    }
  
  
  // Look for new cards
  if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) 
  {
    return;
  }
  //Show UID on serial monitor
  Serial.print("UID tag :");
  String content= "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++) 
  {
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     Serial.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print("Message : ");
  content.toUpperCase();
  
  // read the state of the pushbutton value:
  buttonState = LOW; /*digitalRead(buttonPin);*/
  // check if the pushbutton is pressed. If it is, the buttonState is HIGH:
  /*if (buttonState == HIGH) {
    // turn LED on:
    Serial.println("stage 1");
    digitalWrite(ledPin, HIGH);
    delay(100);
  } else {
    // turn LED off:
    digitalWrite(ledPin, LOW);
  }*/

    if (content.substring(1) == player_pink && Player==1) //change here the UID of the card/cards that you want to give access
    {
      
      tone(buzzer, 1000); // Send 1KHz sound signal...
      delay(1000);
      noTone(buzzer);
      Serial.println(" player 1");
      pink = true;
     
      StartTime=millis(); //επιστρέφει τα μιλισεκοντ από την ώρα που ανοιξε το arduino
     
         
    }
   
    
        if ((content.substring(1) == object_1) && (pink == true))
        {
          Serial.println("stage 2");
          digitalWrite(ledPin, HIGH);
          delay(1000);
          digitalWrite(ledPin,LOW);
          pink = false; 
          count++;
          setColor (0,0,0);
          
        }
     
     
    
    if (content.substring(1) == player_green && Player==2 ) //change here the UID of the card/cards that you want to give access
  {
    tone(buzzer, 1000); // Send 1KHz sound signal...
    delay(1000);
    noTone(buzzer);
    Serial.println(" player 2");
    green = true ; 
    StartTime=millis(); //επιστρέφει τα μιλισεκοντ από την ώρα που ανοιξε το arduino
   
   }
   
        if ((content.substring(1) == object_2) && (green == true))
        {
          digitalWrite(ledPin, HIGH);
          delay(1000);
          digitalWrite(ledPin,LOW);
        green = false;
         count++;
         setColor (0,0,0);
     }
   if (content.substring(1) == player_orange && Player==3) //change here the UID of the card/cards that you want to give access
  {
    tone(buzzer, 1000); // Send 1KHz sound signal...
    delay(1000);
    noTone(buzzer);
    Serial.println(" player 3");
    orange = true ;  
    StartTime=millis(); //επιστρέφει τα μιλισεκοντ από την ώρα που ανοιξε το arduino
   
  }
 
        if ((content.substring(1) == object_3) && (orange == true))
        {
          digitalWrite(ledPin, HIGH);
          delay(1000);
          digitalWrite(ledPin,LOW);
         
        orange = false;
         count++;
       setColor (0,0,0);
     }
     
    if (content.substring(1) == player_red && Player==4) //change here the UID of the card/cards that you want to give access
  {
    tone(buzzer, 1000); // Send 1KHz sound signal...
    delay(1000);
    noTone(buzzer);
    Serial.println(" player 4");
    red = true ; 
    StartTime=millis(); //επιστρέφει τα μιλισεκοντ από την ώρα που ανοιξε το arduino 
    
  }
 
        if ((content.substring(1) == object_4) && (red == true))
        {
          digitalWrite(ledPin, HIGH);
          delay(1000);
          digitalWrite(ledPin,LOW);
        
        red = false;
        count++;
      setColor (0,0,0);
     }
    if (content.substring(1) == player_blue && Player==5 ) //change here the UID of the card/cards that you want to give access
  {
    tone(buzzer, 1000); // Send 1KHz sound signal...
    delay(1000);
    noTone(buzzer);
    Serial.println(" player 5");
    blue = true ;  
    StartTime=millis(); //επιστρέφει τα μιλισεκοντ από την ώρα που ανοιξε το arduino
   
  }
  
        if ((content.substring(1) == object_5) && (blue == true))
        {
          digitalWrite(ledPin, HIGH);
          delay(1000);
          digitalWrite(ledPin,LOW);
        
        blue = false;
         count++;
          setColor (0,0,0);
     }
}
  
